# TODO
# - lrzip should link to shared lrzip library
#
# Conditional build:
%bcond_with	system_lzma	# use system lzma instead of internal
%bcond_without	static_libs	# don't build static libraries
%bcond_without	asm	# Enable native Assembly code (ia32 only)
%bcond_without	jit	# JIT in bundled libzpaq
%bcond_without	tests		# build without tests

%ifnarch %{ix86} %{x8664}
%undefine	with_jit
%endif

%ifnarch %{ix86}
%undefine	with_asm
%endif

Summary:	Long Range ZIP or Lzma RZIP
Summary(pl.UTF-8):	Long Range ZIP lub Lzma RZIP
Name:		lrzip
Version:	0.621
Release:	1
License:	GPL v2
Group:		Applications/Archiving
Source0:	http://ck.kolivas.org/apps/lrzip/%{name}-%{version}.tar.bz2
# Source0-md5:	53a12cc4d19aa030d0ab7f0a21db2cfe
Patch0:		%{name}-lzma.patch
URL:		http://ck.kolivas.org/apps/lrzip/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bzip2-devel
BuildRequires:	libstdc++-devel
%{?with_system_lzma:BuildRequires:	lzma-devel >= 4.43-5}
BuildRequires:	lzo-devel >= 2.02-1
%{?with_asm:BuildRequires:	nasm}
BuildRequires:	perl-tools-pod
BuildRequires:	pkgconfig
BuildRequires:	zlib-devel
# does not link with shared lib, see TODO
#Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is a compression program optimised for large files. The larger
the file and the more memory you have, the better the compression
advantage this will provide, especially once the files are larger than
100MB. The advantage can be chosen to be either size (much smaller
than bzip2) or speed (much faster than bzip2). Decompression is much
always faster than bzip2.

%description -l pl.UTF-8
LRZIP to program kompresujący zoptymalizowany dla dużych plików. Im
większy jest plik i im więcej jest dostępnej pamięci, tym lepszą
kompresję można uzyskać, zwłaszcza dla plików większych niż 100MB.
Można wybrać kompresję bardziej korzystną pod względem rozmiaru (dużo
mniejszy niż bzip2) lub szybkości (dużo szybszy niż bzip2).
Dekompresja jest zawsze dużo szybsza niż bzip2.

%package libs
Summary:	Long Range ZIP library
License:	LGPL v2+
Provides:	bundled(zpaq)

%description    libs
Dynamic library implementing Long Range ZIP or Lzma RZIP algorithm and
archive format.

%package devel
Summary:	Development files for Long Range ZIP library
License:	LGPL v2+
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Files needed to develop application using Long Range ZIP library.

%package static
Summary:	Static Long Range ZIP library
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Provides:	bundled(zpaq)

%description static
Static library implementing Long Range ZIP or Lzma RZIP algorithm and
archive format.

%prep
%setup -q
%if %{with system_lzma}
rm -rf lzma
%patch0 -p1
%endif

%build
%{__aclocal} -I m4
%{__autoconf}
%{!?with_jit:CPPFLAGS="%{rpmcppflags} -DNOJIT"}
%configure \
	--disable-silent-rules \
	--disable-static-bin \
	%{!?with_static_libs:--disable-static} \
	--enable-shared \
	%{__enable_disable asm}
%{__make}

%if %{with tests}
./lrzip -z COPYING
./lrzip --info COPYING.lrz
./lrzip -d -o COPYING.new COPYING.lrz
cmp COPYING COPYING.new
rm COPYING.new
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/liblrzip.la

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS BUGS ChangeLog README* README-NOT-BACKWARD-COMPATIBLE TODO WHATS-NEW
%attr(755,root,root) %{_bindir}/lrunzip
%attr(755,root,root) %{_bindir}/lrzcat
%attr(755,root,root) %{_bindir}/lrzip
%attr(755,root,root) %{_bindir}/lrztar
%attr(755,root,root) %{_bindir}/lrzuntar
%{_mandir}/man1/lrunzip.1*
%{_mandir}/man1/lrzcat.1*
%{_mandir}/man1/lrzip.1*
%{_mandir}/man1/lrztar.1*
%{_mandir}/man1/lrzuntar.1*
%{_mandir}/man5/lrzip.conf.5*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblrzip.so.*.*.*
%ghost %{_libdir}/liblrzip.so.0

%files devel
%defattr(644,root,root,755)
%doc lzma/7zC.txt lzma/7zFormat.txt lzma/Methods.txt lzma/README lzma/README-Alloc lzma/history.txt lzma/lzma.txt
%doc doc/magic.header.txt doc/lrzip.conf.example doc/README.lzo_compresses.test.txt doc/README.benchmarks
%{_includedir}/Lrzip.h
%{_libdir}/liblrzip.so
%{_pkgconfigdir}/lrzip.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/liblrzip.a
%endif
%changelog
* Sun Apr 10 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lrzip.git;a=log;h=master

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 72859bc
- bin doesn't use own shared lib

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 14d15fe
- static lib, fix descriptions

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 9146d35
- BR pkconfig

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 592352c
- trivial compress/decompress test

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> ed9f2b8
- jit bcond

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 2bb9831
- ASM is 32 bit only

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 48e6d72
- package shared library, available since lrzip-0.610

* Sun Apr 10 2016 Elan Ruusamäe <glen@delfi.ee> 39ddaf6
- up to 0.621 (MARCH 2015)

* Sun Oct 21 2012 Karol Krenski <charles@pld-linux.org> 26ef3c2
- up to 0.614

* Thu Jan 12 2012 zbyniu <zbyniu@pld-linux.org> 9740a7a
- up to 0.608

* Sat May 14 2011 Karol Krenski <charles@pld-linux.org> fa6bd61
- up to 0.606 (bugfix release)

* Sun May 08 2011 Karol Krenski <charles@pld-linux.org> ff0c2b9
- updated to 0.605

* Sat Apr 30 2011 areq <areq@pld-linux.org> b42af76
- 0.604

* Wed Apr 13 2011 areq <areq@pld-linux.org> bf17e47
- 0.602

* Tue Mar 08 2011 areq <areq@pld-linux.org> aea99f9
- 0.571

* Fri Feb 25 2011 areq <areq@pld-linux.org> e7f13eb
- 0.570

* Mon Feb 21 2011 areq <areq@pld-linux.org> ffa7079
- 0.560

* Sat Feb 12 2011 sparky <sparky@pld-linux.org> e0b40e4
- BR: perl-tools-pod

* Sat Feb 12 2011 Artur Frysiak <artur@frysiak.net> 6fccaa9
- up to 0.552
- lzma.patch not updated

* Tue Nov 24 2009 Elan Ruusamäe <glen@pld-linux.org> 89dd577
- release 2

